// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rcss3d_agent_msgs:msg/AgentState.idl
// generated code does not contain a copyright notice
#include "rcss3d_agent_msgs/msg/detail/agent_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
rcss3d_agent_msgs__msg__AgentState__init(rcss3d_agent_msgs__msg__AgentState * msg)
{
  if (!msg) {
    return false;
  }
  // temp
  // battery
  return true;
}

void
rcss3d_agent_msgs__msg__AgentState__fini(rcss3d_agent_msgs__msg__AgentState * msg)
{
  if (!msg) {
    return;
  }
  // temp
  // battery
}

bool
rcss3d_agent_msgs__msg__AgentState__are_equal(const rcss3d_agent_msgs__msg__AgentState * lhs, const rcss3d_agent_msgs__msg__AgentState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // temp
  if (lhs->temp != rhs->temp) {
    return false;
  }
  // battery
  if (lhs->battery != rhs->battery) {
    return false;
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__AgentState__copy(
  const rcss3d_agent_msgs__msg__AgentState * input,
  rcss3d_agent_msgs__msg__AgentState * output)
{
  if (!input || !output) {
    return false;
  }
  // temp
  output->temp = input->temp;
  // battery
  output->battery = input->battery;
  return true;
}

rcss3d_agent_msgs__msg__AgentState *
rcss3d_agent_msgs__msg__AgentState__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__AgentState * msg = (rcss3d_agent_msgs__msg__AgentState *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__AgentState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rcss3d_agent_msgs__msg__AgentState));
  bool success = rcss3d_agent_msgs__msg__AgentState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rcss3d_agent_msgs__msg__AgentState__destroy(rcss3d_agent_msgs__msg__AgentState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rcss3d_agent_msgs__msg__AgentState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rcss3d_agent_msgs__msg__AgentState__Sequence__init(rcss3d_agent_msgs__msg__AgentState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__AgentState * data = NULL;

  if (size) {
    data = (rcss3d_agent_msgs__msg__AgentState *)allocator.zero_allocate(size, sizeof(rcss3d_agent_msgs__msg__AgentState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rcss3d_agent_msgs__msg__AgentState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rcss3d_agent_msgs__msg__AgentState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rcss3d_agent_msgs__msg__AgentState__Sequence__fini(rcss3d_agent_msgs__msg__AgentState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rcss3d_agent_msgs__msg__AgentState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rcss3d_agent_msgs__msg__AgentState__Sequence *
rcss3d_agent_msgs__msg__AgentState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rcss3d_agent_msgs__msg__AgentState__Sequence * array = (rcss3d_agent_msgs__msg__AgentState__Sequence *)allocator.allocate(sizeof(rcss3d_agent_msgs__msg__AgentState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rcss3d_agent_msgs__msg__AgentState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rcss3d_agent_msgs__msg__AgentState__Sequence__destroy(rcss3d_agent_msgs__msg__AgentState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rcss3d_agent_msgs__msg__AgentState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rcss3d_agent_msgs__msg__AgentState__Sequence__are_equal(const rcss3d_agent_msgs__msg__AgentState__Sequence * lhs, const rcss3d_agent_msgs__msg__AgentState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rcss3d_agent_msgs__msg__AgentState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rcss3d_agent_msgs__msg__AgentState__Sequence__copy(
  const rcss3d_agent_msgs__msg__AgentState__Sequence * input,
  rcss3d_agent_msgs__msg__AgentState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rcss3d_agent_msgs__msg__AgentState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rcss3d_agent_msgs__msg__AgentState * data =
      (rcss3d_agent_msgs__msg__AgentState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rcss3d_agent_msgs__msg__AgentState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rcss3d_agent_msgs__msg__AgentState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rcss3d_agent_msgs__msg__AgentState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
