// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rcss3d_agent_msgs:msg/Hear.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/hear.hpp"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__TRAITS_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rcss3d_agent_msgs/msg/detail/hear__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rcss3d_agent_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Hear & msg,
  std::ostream & out)
{
  out << "{";
  // member: team
  {
    out << "team: ";
    rosidl_generator_traits::value_to_yaml(msg.team, out);
    out << ", ";
  }

  // member: time
  {
    out << "time: ";
    rosidl_generator_traits::value_to_yaml(msg.time, out);
    out << ", ";
  }

  // member: self
  {
    out << "self: ";
    rosidl_generator_traits::value_to_yaml(msg.self, out);
    out << ", ";
  }

  // member: direction
  {
    if (msg.direction.size() == 0) {
      out << "direction: []";
    } else {
      out << "direction: [";
      size_t pending_items = msg.direction.size();
      for (auto item : msg.direction) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Hear & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: team
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team: ";
    rosidl_generator_traits::value_to_yaml(msg.team, out);
    out << "\n";
  }

  // member: time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time: ";
    rosidl_generator_traits::value_to_yaml(msg.time, out);
    out << "\n";
  }

  // member: self
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "self: ";
    rosidl_generator_traits::value_to_yaml(msg.self, out);
    out << "\n";
  }

  // member: direction
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.direction.size() == 0) {
      out << "direction: []\n";
    } else {
      out << "direction:\n";
      for (auto item : msg.direction) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Hear & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rcss3d_agent_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rcss3d_agent_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rcss3d_agent_msgs::msg::Hear & msg,
  std::ostream & out, size_t indentation = 0)
{
  rcss3d_agent_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rcss3d_agent_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rcss3d_agent_msgs::msg::Hear & msg)
{
  return rcss3d_agent_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rcss3d_agent_msgs::msg::Hear>()
{
  return "rcss3d_agent_msgs::msg::Hear";
}

template<>
inline const char * name<rcss3d_agent_msgs::msg::Hear>()
{
  return "rcss3d_agent_msgs/msg/Hear";
}

template<>
struct has_fixed_size<rcss3d_agent_msgs::msg::Hear>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rcss3d_agent_msgs::msg::Hear>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rcss3d_agent_msgs::msg::Hear>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__HEAR__TRAITS_HPP_
