// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rcss3d_agent_msgs:msg/Percept.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/percept.hpp"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__PERCEPT__STRUCT_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__PERCEPT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'gyro_rates'
#include "rcss3d_agent_msgs/msg/detail/gyro_rate__struct.hpp"
// Member 'hinge_joints'
#include "rcss3d_agent_msgs/msg/detail/hinge_joint_pos__struct.hpp"
// Member 'universal_joints'
#include "rcss3d_agent_msgs/msg/detail/universal_joint_pos__struct.hpp"
// Member 'force_resistances'
#include "rcss3d_agent_msgs/msg/detail/force_resistance__struct.hpp"
// Member 'accelerometers'
#include "rcss3d_agent_msgs/msg/detail/accelerometer__struct.hpp"
// Member 'vision'
#include "rcss3d_agent_msgs/msg/detail/vision__struct.hpp"
// Member 'game_state'
#include "rcss3d_agent_msgs/msg/detail/game_state__struct.hpp"
// Member 'agent_state'
#include "rcss3d_agent_msgs/msg/detail/agent_state__struct.hpp"
// Member 'hears'
#include "rcss3d_agent_msgs/msg/detail/hear__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rcss3d_agent_msgs__msg__Percept __attribute__((deprecated))
#else
# define DEPRECATED__rcss3d_agent_msgs__msg__Percept __declspec(deprecated)
#endif

namespace rcss3d_agent_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Percept_
{
  using Type = Percept_<ContainerAllocator>;

  explicit Percept_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : game_state(_init)
  {
    (void)_init;
  }

  explicit Percept_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : game_state(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _gyro_rates_type =
    std::vector<rcss3d_agent_msgs::msg::GyroRate_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::GyroRate_<ContainerAllocator>>>;
  _gyro_rates_type gyro_rates;
  using _hinge_joints_type =
    std::vector<rcss3d_agent_msgs::msg::HingeJointPos_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::HingeJointPos_<ContainerAllocator>>>;
  _hinge_joints_type hinge_joints;
  using _universal_joints_type =
    std::vector<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>>;
  _universal_joints_type universal_joints;
  using _force_resistances_type =
    std::vector<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>>;
  _force_resistances_type force_resistances;
  using _accelerometers_type =
    std::vector<rcss3d_agent_msgs::msg::Accelerometer_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Accelerometer_<ContainerAllocator>>>;
  _accelerometers_type accelerometers;
  using _vision_type =
    rosidl_runtime_cpp::BoundedVector<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>>;
  _vision_type vision;
  using _game_state_type =
    rcss3d_agent_msgs::msg::GameState_<ContainerAllocator>;
  _game_state_type game_state;
  using _agent_state_type =
    rosidl_runtime_cpp::BoundedVector<rcss3d_agent_msgs::msg::AgentState_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::AgentState_<ContainerAllocator>>>;
  _agent_state_type agent_state;
  using _hears_type =
    std::vector<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>>;
  _hears_type hears;

  // setters for named parameter idiom
  Type & set__gyro_rates(
    const std::vector<rcss3d_agent_msgs::msg::GyroRate_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::GyroRate_<ContainerAllocator>>> & _arg)
  {
    this->gyro_rates = _arg;
    return *this;
  }
  Type & set__hinge_joints(
    const std::vector<rcss3d_agent_msgs::msg::HingeJointPos_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::HingeJointPos_<ContainerAllocator>>> & _arg)
  {
    this->hinge_joints = _arg;
    return *this;
  }
  Type & set__universal_joints(
    const std::vector<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::UniversalJointPos_<ContainerAllocator>>> & _arg)
  {
    this->universal_joints = _arg;
    return *this;
  }
  Type & set__force_resistances(
    const std::vector<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::ForceResistance_<ContainerAllocator>>> & _arg)
  {
    this->force_resistances = _arg;
    return *this;
  }
  Type & set__accelerometers(
    const std::vector<rcss3d_agent_msgs::msg::Accelerometer_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Accelerometer_<ContainerAllocator>>> & _arg)
  {
    this->accelerometers = _arg;
    return *this;
  }
  Type & set__vision(
    const rosidl_runtime_cpp::BoundedVector<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Vision_<ContainerAllocator>>> & _arg)
  {
    this->vision = _arg;
    return *this;
  }
  Type & set__game_state(
    const rcss3d_agent_msgs::msg::GameState_<ContainerAllocator> & _arg)
  {
    this->game_state = _arg;
    return *this;
  }
  Type & set__agent_state(
    const rosidl_runtime_cpp::BoundedVector<rcss3d_agent_msgs::msg::AgentState_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::AgentState_<ContainerAllocator>>> & _arg)
  {
    this->agent_state = _arg;
    return *this;
  }
  Type & set__hears(
    const std::vector<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rcss3d_agent_msgs::msg::Hear_<ContainerAllocator>>> & _arg)
  {
    this->hears = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rcss3d_agent_msgs::msg::Percept_<ContainerAllocator> *;
  using ConstRawPtr =
    const rcss3d_agent_msgs::msg::Percept_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Percept_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rcss3d_agent_msgs::msg::Percept_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Percept
    std::shared_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rcss3d_agent_msgs__msg__Percept
    std::shared_ptr<rcss3d_agent_msgs::msg::Percept_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Percept_ & other) const
  {
    if (this->gyro_rates != other.gyro_rates) {
      return false;
    }
    if (this->hinge_joints != other.hinge_joints) {
      return false;
    }
    if (this->universal_joints != other.universal_joints) {
      return false;
    }
    if (this->force_resistances != other.force_resistances) {
      return false;
    }
    if (this->accelerometers != other.accelerometers) {
      return false;
    }
    if (this->vision != other.vision) {
      return false;
    }
    if (this->game_state != other.game_state) {
      return false;
    }
    if (this->agent_state != other.agent_state) {
      return false;
    }
    if (this->hears != other.hears) {
      return false;
    }
    return true;
  }
  bool operator!=(const Percept_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Percept_

// alias to use template instance with default allocator
using Percept =
  rcss3d_agent_msgs::msg::Percept_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rcss3d_agent_msgs

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__PERCEPT__STRUCT_HPP_
