// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rcss3d_agent_msgs:msg/Player.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/player.hpp"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__PLAYER__TRAITS_HPP_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__PLAYER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rcss3d_agent_msgs/msg/detail/player__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'head'
// Member 'rlowerarm'
// Member 'llowerarm'
// Member 'rfoot'
// Member 'lfoot'
#include "rcss3d_agent_msgs/msg/detail/spherical__traits.hpp"

namespace rcss3d_agent_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Player & msg,
  std::ostream & out)
{
  out << "{";
  // member: team
  {
    out << "team: ";
    rosidl_generator_traits::value_to_yaml(msg.team, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: head
  {
    if (msg.head.size() == 0) {
      out << "head: []";
    } else {
      out << "head: [";
      size_t pending_items = msg.head.size();
      for (auto item : msg.head) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: rlowerarm
  {
    if (msg.rlowerarm.size() == 0) {
      out << "rlowerarm: []";
    } else {
      out << "rlowerarm: [";
      size_t pending_items = msg.rlowerarm.size();
      for (auto item : msg.rlowerarm) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: llowerarm
  {
    if (msg.llowerarm.size() == 0) {
      out << "llowerarm: []";
    } else {
      out << "llowerarm: [";
      size_t pending_items = msg.llowerarm.size();
      for (auto item : msg.llowerarm) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: rfoot
  {
    if (msg.rfoot.size() == 0) {
      out << "rfoot: []";
    } else {
      out << "rfoot: [";
      size_t pending_items = msg.rfoot.size();
      for (auto item : msg.rfoot) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: lfoot
  {
    if (msg.lfoot.size() == 0) {
      out << "lfoot: []";
    } else {
      out << "lfoot: [";
      size_t pending_items = msg.lfoot.size();
      for (auto item : msg.lfoot) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Player & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: team
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "team: ";
    rosidl_generator_traits::value_to_yaml(msg.team, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: head
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.head.size() == 0) {
      out << "head: []\n";
    } else {
      out << "head:\n";
      for (auto item : msg.head) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: rlowerarm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.rlowerarm.size() == 0) {
      out << "rlowerarm: []\n";
    } else {
      out << "rlowerarm:\n";
      for (auto item : msg.rlowerarm) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: llowerarm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.llowerarm.size() == 0) {
      out << "llowerarm: []\n";
    } else {
      out << "llowerarm:\n";
      for (auto item : msg.llowerarm) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: rfoot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.rfoot.size() == 0) {
      out << "rfoot: []\n";
    } else {
      out << "rfoot:\n";
      for (auto item : msg.rfoot) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: lfoot
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.lfoot.size() == 0) {
      out << "lfoot: []\n";
    } else {
      out << "lfoot:\n";
      for (auto item : msg.lfoot) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Player & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rcss3d_agent_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rcss3d_agent_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rcss3d_agent_msgs::msg::Player & msg,
  std::ostream & out, size_t indentation = 0)
{
  rcss3d_agent_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rcss3d_agent_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rcss3d_agent_msgs::msg::Player & msg)
{
  return rcss3d_agent_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rcss3d_agent_msgs::msg::Player>()
{
  return "rcss3d_agent_msgs::msg::Player";
}

template<>
inline const char * name<rcss3d_agent_msgs::msg::Player>()
{
  return "rcss3d_agent_msgs/msg/Player";
}

template<>
struct has_fixed_size<rcss3d_agent_msgs::msg::Player>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rcss3d_agent_msgs::msg::Player>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rcss3d_agent_msgs::msg::Player>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__PLAYER__TRAITS_HPP_
