// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rcss3d_agent_msgs:msg/Synchronize.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "rcss3d_agent_msgs/msg/synchronize.h"


#ifndef RCSS3D_AGENT_MSGS__MSG__DETAIL__SYNCHRONIZE__STRUCT_H_
#define RCSS3D_AGENT_MSGS__MSG__DETAIL__SYNCHRONIZE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Struct defined in msg/Synchronize in the package rcss3d_agent_msgs.
/**
  * Synchronize Effector - Agents running in Agent Sync Mode must send this command at the end of
  * each simulation cycle. 
  * The server ignores this command if it is received in Real-Time Mode, so it is safe to 
  * configure your agent to always append this command to your agent's responses.
 */
typedef struct rcss3d_agent_msgs__msg__Synchronize
{
  uint8_t structure_needs_at_least_one_member;
} rcss3d_agent_msgs__msg__Synchronize;

// Struct for a sequence of rcss3d_agent_msgs__msg__Synchronize.
typedef struct rcss3d_agent_msgs__msg__Synchronize__Sequence
{
  rcss3d_agent_msgs__msg__Synchronize * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rcss3d_agent_msgs__msg__Synchronize__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RCSS3D_AGENT_MSGS__MSG__DETAIL__SYNCHRONIZE__STRUCT_H_
